/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreTranslationKey.TCoreTranslationKeyPath;
import de.ship.db.tables.TDmMaillist.TDmMaillistPath;
import de.ship.db.tables.records.TDmRecipientRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TDmRecipient extends TableImpl<TDmRecipientRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_dm_recipient</code>
     */
    public static final TDmRecipient T_DM_RECIPIENT = new TDmRecipient();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TDmRecipientRecord> getRecordType() {
        return TDmRecipientRecord.class;
    }

    /**
     * The column <code>common_dd.t_dm_recipient.lastchange</code>.
     */
    public final TableField<TDmRecipientRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_dm_recipient.pk</code>. RECIP: id for type
     * of recipient
     */
    public final TableField<TDmRecipientRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "RECIP: id for type of recipient");

    /**
     * The column <code>common_dd.t_dm_recipient.fk_lang</code>. RECIP: language
     * key for the recipient
     */
    public final TableField<TDmRecipientRecord, String> FK_LANG = createField(DSL.name("fk_lang"), SQLDataType.CLOB.nullable(false), this, "RECIP: language key for the recipient");

    private TDmRecipient(Name alias, Table<TDmRecipientRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TDmRecipient(Name alias, Table<TDmRecipientRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_recipient</code> table reference
     */
    public TDmRecipient(String alias) {
        this(DSL.name(alias), T_DM_RECIPIENT);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_recipient</code> table reference
     */
    public TDmRecipient(Name alias) {
        this(alias, T_DM_RECIPIENT);
    }

    /**
     * Create a <code>common_dd.t_dm_recipient</code> table reference
     */
    public TDmRecipient() {
        this(DSL.name("t_dm_recipient"), null);
    }

    public <O extends Record> TDmRecipient(Table<O> path, ForeignKey<O, TDmRecipientRecord> childPath, InverseForeignKey<O, TDmRecipientRecord> parentPath) {
        super(path, childPath, parentPath, T_DM_RECIPIENT);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TDmRecipientPath extends TDmRecipient implements Path<TDmRecipientRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TDmRecipientPath(Table<O> path, ForeignKey<O, TDmRecipientRecord> childPath, InverseForeignKey<O, TDmRecipientRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TDmRecipientPath(Name alias, Table<TDmRecipientRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TDmRecipientPath as(String alias) {
            return new TDmRecipientPath(DSL.name(alias), this);
        }

        @Override
        public TDmRecipientPath as(Name alias) {
            return new TDmRecipientPath(alias, this);
        }

        @Override
        public TDmRecipientPath as(Table<?> alias) {
            return new TDmRecipientPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TDmRecipientRecord, Integer> getIdentity() {
        return (Identity<TDmRecipientRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TDmRecipientRecord> getPrimaryKey() {
        return Keys.PK_DM_RECIPIENT;
    }

    @Override
    public List<ForeignKey<TDmRecipientRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_DM_RECIPIENT__FK_RECIP_LANG);
    }

    private transient TCoreTranslationKeyPath _tCoreTranslationKey;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_translation_key</code> table.
     */
    public TCoreTranslationKeyPath tCoreTranslationKey() {
        if (_tCoreTranslationKey == null)
            _tCoreTranslationKey = new TCoreTranslationKeyPath(this, Keys.T_DM_RECIPIENT__FK_RECIP_LANG, null);

        return _tCoreTranslationKey;
    }

    private transient TDmMaillistPath _tDmMaillist;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_dm_maillist</code> table
     */
    public TDmMaillistPath tDmMaillist() {
        if (_tDmMaillist == null)
            _tDmMaillist = new TDmMaillistPath(this, null, Keys.T_DM_MAILLIST__FK_MAILLIST_RECIP.getInverseKey());

        return _tDmMaillist;
    }

    @Override
    public TDmRecipient as(String alias) {
        return new TDmRecipient(DSL.name(alias), this);
    }

    @Override
    public TDmRecipient as(Name alias) {
        return new TDmRecipient(alias, this);
    }

    @Override
    public TDmRecipient as(Table<?> alias) {
        return new TDmRecipient(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmRecipient rename(String name) {
        return new TDmRecipient(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmRecipient rename(Name name) {
        return new TDmRecipient(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmRecipient rename(Table<?> name) {
        return new TDmRecipient(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmRecipient where(Condition condition) {
        return new TDmRecipient(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmRecipient where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmRecipient where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmRecipient where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmRecipient where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmRecipient where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmRecipient where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmRecipient where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmRecipient whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmRecipient whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
